<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.12"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>eduRayTracer: src/Vertex.hpp Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
  $(document).ready(initResizable);
</script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">eduRayTracer
   &#160;<span id="projectnumber">v_2017_2018_1</span>
   </div>
   <div id="projectbrief">An Educational Ray Tracing Software Package (by Pedro Santana, ISCTE-IUL)</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.12 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
$(document).ready(function(){initNavTree('_vertex_8hpp_source.html','');});
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">Vertex.hpp</div>  </div>
</div><!--header-->
<div class="contents">
<a href="_vertex_8hpp.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">/*</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment"> * eduRayTracer - An Educational Ray Tracing Software Package</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment"> * Contributor(s): Pedro Santana - ISCTE-IUL (2014-2016)</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment"> */</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;</div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="preprocessor">#ifndef _H_Vertex_</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="preprocessor">#define _H_Vertex_</span></div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;</div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="_vec_8hpp.html">Vec.hpp</a>&quot;</span></div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="_material_8hpp.html">Material.hpp</a>&quot;</span></div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="_transform_8hpp.html">Transform.hpp</a>&quot;</span></div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;</div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="preprocessor">#include &lt;iostream&gt;</span></div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="preprocessor">#include &lt;math.h&gt;</span></div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;</div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;</div><div class="line"><a name="l00018"></a><span class="lineno"><a class="line" href="class_vertex.html">   18</a></span>&#160;<span class="keyword">class </span><a class="code" href="class_vertex.html">Vertex</a>{</div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="keyword">public</span>:</div><div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;</div><div class="line"><a name="l00022"></a><span class="lineno"><a class="line" href="class_vertex.html#ac8b579bc65f2832530987cae7bca5c3e">   22</a></span>&#160;    <a class="code" href="class_vec.html">Vec</a> <a class="code" href="class_vertex.html#ac8b579bc65f2832530987cae7bca5c3e">local_o</a>;</div><div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;</div><div class="line"><a name="l00025"></a><span class="lineno"><a class="line" href="class_vertex.html#af633aabbd5adf4a3c59b32e87816ebbe">   25</a></span>&#160;    <a class="code" href="class_vec.html">Vec</a> <a class="code" href="class_vertex.html#af633aabbd5adf4a3c59b32e87816ebbe">o</a>; </div><div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;</div><div class="line"><a name="l00028"></a><span class="lineno"><a class="line" href="class_vertex.html#a749a6f6b57ce11fda6ce662619351939">   28</a></span>&#160;    <a class="code" href="class_vec.html">Vec</a> <a class="code" href="class_vertex.html#a749a6f6b57ce11fda6ce662619351939">local_n</a>;</div><div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;</div><div class="line"><a name="l00031"></a><span class="lineno"><a class="line" href="class_vertex.html#ad5c064cd79d633ab294dd6623da86163">   31</a></span>&#160;    <a class="code" href="class_vec.html">Vec</a> <a class="code" href="class_vertex.html#ad5c064cd79d633ab294dd6623da86163">n</a>;</div><div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;</div><div class="line"><a name="l00034"></a><span class="lineno"><a class="line" href="class_vertex.html#a7b05126ac048975668016c73345e01b1">   34</a></span>&#160;    <a class="code" href="class_vec.html">Vec</a> <a class="code" href="class_vertex.html#a7b05126ac048975668016c73345e01b1">tex_coord</a>;</div><div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;</div><div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;</div><div class="line"><a name="l00040"></a><span class="lineno"><a class="line" href="class_vertex.html#a6332c587d567181ce2a8a91d380b6fc2">   40</a></span>&#160;    <a class="code" href="class_vertex.html#a6332c587d567181ce2a8a91d380b6fc2">Vertex</a>(<a class="code" href="class_vec.html">Vec</a> _o) : local_o(_o), o(_o) {}</div><div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;</div><div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;</div><div class="line"><a name="l00047"></a><span class="lineno"><a class="line" href="class_vertex.html#ad5fd9b77c6083e5a7e08550eb1cfe848">   47</a></span>&#160;    <a class="code" href="class_vertex.html#ad5fd9b77c6083e5a7e08550eb1cfe848">Vertex</a>(<a class="code" href="class_vec.html">Vec</a> _o, <a class="code" href="class_vec.html">Vec</a> _tex_coord) : local_o(_o), o(_o), tex_coord(_tex_coord) {}</div><div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;    </div><div class="line"><a name="l00049"></a><span class="lineno"><a class="line" href="class_vertex.html#a97488994a2482d70da74e1b91d40e169">   49</a></span>&#160;    <a class="code" href="class_vertex.html#a97488994a2482d70da74e1b91d40e169">Vertex</a>() {}</div><div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;</div><div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;</div><div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="class_vertex.html#a0910d793f80561fbf49e8a81be889afc">transform</a>(<a class="code" href="class_transform.html">Transform</a> *tf);</div><div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;};</div><div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;</div><div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;</div><div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;<span class="preprocessor">#endif</span></div><div class="ttc" id="class_vertex_html"><div class="ttname"><a href="class_vertex.html">Vertex</a></div><div class="ttdoc">A class to create and manipulate 3D vertexes. </div><div class="ttdef"><b>Definition:</b> Vertex.hpp:18</div></div>
<div class="ttc" id="class_vertex_html_a7b05126ac048975668016c73345e01b1"><div class="ttname"><a href="class_vertex.html#a7b05126ac048975668016c73345e01b1">Vertex::tex_coord</a></div><div class="ttdeci">Vec tex_coord</div><div class="ttdoc">2D texture coordinates of the Vertex (don&amp;#39;t care about the 3rd coordinate of the Vec) ...</div><div class="ttdef"><b>Definition:</b> Vertex.hpp:34</div></div>
<div class="ttc" id="class_vertex_html_ac8b579bc65f2832530987cae7bca5c3e"><div class="ttname"><a href="class_vertex.html#ac8b579bc65f2832530987cae7bca5c3e">Vertex::local_o</a></div><div class="ttdeci">Vec local_o</div><div class="ttdoc">Vertex&amp;#39;s position in the local frame of reference (computed elsewhere) </div><div class="ttdef"><b>Definition:</b> Vertex.hpp:22</div></div>
<div class="ttc" id="class_vertex_html_ad5c064cd79d633ab294dd6623da86163"><div class="ttname"><a href="class_vertex.html#ad5c064cd79d633ab294dd6623da86163">Vertex::n</a></div><div class="ttdeci">Vec n</div><div class="ttdoc">Vertex&amp;#39;s associated normal in the global frame of reference - updated with transform() ...</div><div class="ttdef"><b>Definition:</b> Vertex.hpp:31</div></div>
<div class="ttc" id="class_transform_html"><div class="ttname"><a href="class_transform.html">Transform</a></div><div class="ttdoc">A class to handle rigid transformations. </div><div class="ttdef"><b>Definition:</b> Transform.hpp:17</div></div>
<div class="ttc" id="class_vertex_html_ad5fd9b77c6083e5a7e08550eb1cfe848"><div class="ttname"><a href="class_vertex.html#ad5fd9b77c6083e5a7e08550eb1cfe848">Vertex::Vertex</a></div><div class="ttdeci">Vertex(Vec _o, Vec _tex_coord)</div><div class="ttdoc">A Vertex constructor with texture coordinates. </div><div class="ttdef"><b>Definition:</b> Vertex.hpp:47</div></div>
<div class="ttc" id="class_vertex_html_af633aabbd5adf4a3c59b32e87816ebbe"><div class="ttname"><a href="class_vertex.html#af633aabbd5adf4a3c59b32e87816ebbe">Vertex::o</a></div><div class="ttdeci">Vec o</div><div class="ttdoc">Vertex&amp;#39;s position in the global frame of reference - updated with transform() </div><div class="ttdef"><b>Definition:</b> Vertex.hpp:25</div></div>
<div class="ttc" id="_transform_8hpp_html"><div class="ttname"><a href="_transform_8hpp.html">Transform.hpp</a></div></div>
<div class="ttc" id="class_vec_html"><div class="ttname"><a href="class_vec.html">Vec</a></div><div class="ttdoc">A class to create and manipulate 3D vectors. These can be used to store positions, normals, and RGB triplets. </div><div class="ttdef"><b>Definition:</b> Vec.hpp:16</div></div>
<div class="ttc" id="class_vertex_html_a6332c587d567181ce2a8a91d380b6fc2"><div class="ttname"><a href="class_vertex.html#a6332c587d567181ce2a8a91d380b6fc2">Vertex::Vertex</a></div><div class="ttdeci">Vertex(Vec _o)</div><div class="ttdoc">A Vertex constructor without texture coordinates. </div><div class="ttdef"><b>Definition:</b> Vertex.hpp:40</div></div>
<div class="ttc" id="class_vertex_html_a97488994a2482d70da74e1b91d40e169"><div class="ttname"><a href="class_vertex.html#a97488994a2482d70da74e1b91d40e169">Vertex::Vertex</a></div><div class="ttdeci">Vertex()</div><div class="ttdef"><b>Definition:</b> Vertex.hpp:49</div></div>
<div class="ttc" id="_material_8hpp_html"><div class="ttname"><a href="_material_8hpp.html">Material.hpp</a></div></div>
<div class="ttc" id="_vec_8hpp_html"><div class="ttname"><a href="_vec_8hpp.html">Vec.hpp</a></div></div>
<div class="ttc" id="class_vertex_html_a0910d793f80561fbf49e8a81be889afc"><div class="ttname"><a href="class_vertex.html#a0910d793f80561fbf49e8a81be889afc">Vertex::transform</a></div><div class="ttdeci">void transform(Transform *tf)</div><div class="ttdef"><b>Definition:</b> Vertex.cpp:8</div></div>
<div class="ttc" id="class_vertex_html_a749a6f6b57ce11fda6ce662619351939"><div class="ttname"><a href="class_vertex.html#a749a6f6b57ce11fda6ce662619351939">Vertex::local_n</a></div><div class="ttdeci">Vec local_n</div><div class="ttdoc">Vertex&amp;#39;s associated normal in the local frame of reference (computed elsewhere) </div><div class="ttdef"><b>Definition:</b> Vertex.hpp:28</div></div>
</div><!-- fragment --></div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="dir_68267d1309a1af8e8297ef4c3efbcdba.html">src</a></li><li class="navelem"><a class="el" href="_vertex_8hpp.html">Vertex.hpp</a></li>
    <li class="footer">Generated on Fri Sep 15 2017 15:54:23 for eduRayTracer by
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.8.12 </li>
  </ul>
</div>
</body>
</html>
